*
* FWINDOW% function.
*  Copyright Mark Knight 1997.
*
* Error=FWINDOW%(#Chan%,Width%,Height%,Across%,Down%).
* Can the window be redefined in this way?  Returns error code if not.
* Useful for writing screen resolution independent SuperBASIC programs.
*
Start      LEA.L       Define,A1       Point to definition.
           MOVE.W      $110,A2         Select BP.INIT routine...
           JMP         (A2)            ...and jump to it (it returns).
*
Fwindow    MOVE.W      $112,A2         Vector to get integers.
           JSR         (A2)            Call CA.GTINT to fetch parameters.
           BNE.S       Bad_Exit        If any error then exit.
           SUBQ.W      #5,D3           5 parameters?
           BNE.S       Bad_Param       Wrong number of parameters.
           MOVE.W      0(A1,A6.L),D0   Get BASIC channel number.
           ADDQ.L      #2,A1           Discard channel Parameter.
           MOVE.L      A1,$58(A6)      Set maths stack pointer.
*
* Next check and convert channel number in D0 to ID in A0
*
Chan_Sel   MULU        #40,D0          Channel table size.
           ADD.L       $30(A6),D0      Add base offset.
           CMP.L       $34(A6),D0      Check against end of channel table.
           BGE.S       What_Chan       Past end of channel table?  If so report.
           MOVE.L      0(A6,D0.L),D0   Fetch channel ID.
           BPL.S       Chan_Open       Channel is open if ID is positive.
What_Chan  MOVEQ       #-6,D0          CHANNEL NOT OPEN error.
Bad_Exit   RTS
Bad_Param  MOVEQ       #-15,D0         BAD PARAMETER error.
           RTS
*
* This routine tries to redefine the window and returns the error if any
* occurs.
*
* It assumes the parameters are on the arithmetic stack in the right order
* for the SD.WDEF call.
*
Chan_Open  MOVE.L      D0,A0           A0 is now channel ID.
           MOVE.L      $58(A6),A1      Fetch maths stack pointer.
           MOVE.L      4(A1,A6.L),-(SP)        Put top 4 bytes on system stack.
           MOVE.L      0(A1,A6.L),-(SP)        Put low 4 bytes on system stack.
           MOVE.L      SP,A1           Point A1 at start of buffer for SD.WDEF.
           MOVE.B      #0,D1           Clear border colour indicator.
           MOVE.W      #0,D2           Border width zero.
           MOVE.W      #-1,D3          Select infinite timeout.
           MOVE.L      #$0D,D0         Select SD.WDEF, redefine window...
           TRAP        #3              ...and call it.
           TST.L       D0              Any error?
           BNE.S       RetErr          Return the error.
           ADDQ.L      #8,SP           Unstack the parameters on system stack.
           MOVE.L      $58(A6),A1      Retrieve maths stack pointer.
           BSR.S       Discard         Throw away parameters on maths stack.
           MOVEQ.L     #0,D1           Return zero result.
*
Return_Int MOVE.W      D1,0(A1,A6.L)   Put result in space on maths stack.
           MOVEQ       #3,D4           Indicate type is INTEGER.
           RTS                         Return result to SuperBASIC.
*
RetErr     ADDQ.L      #8,SP           Unstack the parameters on system stack.
           MOVE.L      $58(A6),A1      Refetch maths stack pointer.
           MOVE.L      D0,D1           Put error code in D1.
           BSR.S       Discard         Throw away parameters on maths stack.
           MOVEQ.L     #0,D0           Signal no error.
           BRA.S       Return_Int      Return the error code instead.
*
* Discard parameters on stack leaving room for one integer.
*
Discard    ADDQ.L      #6,A1           Throw away six bytes on maths stack.
           MOVE.L      A1,$58(A6)      Save maths stack pointer.
           RTS
*
Define     DC.W        0               No PROCedures.
           DC.W        0               End of PROCedures list.
           DC.W        1               One FuNction.
           DC.W        Fwindow-*       Address of routine.
           DC.B        8               Length of name...
           DC.B        'FWINDOW%'      ...name.
           DC.W        0               End of functions.
           DC.W        0               End of list.
           END
