*
* Working version of the QL DATE function as written by Mark Knight.
*
Start      MOVE.W      $110,A0         $110 = BP.INIT vector
           LEA.L       Defines,A1      Load definition address into A1
           JMP         (A0)            jump to BP.INIT it will return to caller
*
DateFind   CMPA.L      A3,A5           Any parameters in name table?
           BEQ.S       NoParams        If not then all is well.
*
           MOVEQ.L     #-19,D0         -19 = NOT IMPLEMENTED error code.
           RTS
*
NoParams   MOVE.L      #$13,D0         Select MT.RCLCK routine.
           TRAP        #1              Call it.
*
LongRet    MOVE.W      D1,D4           D4 will be exponent.
           MOVE.L      D1,D5           D5 will be mantissa.
           BEQ.S       Norlised        Zero is a trivial case.
           MOVE.W      #2079,D4        First guess at exponent.
           ADD.L       D1,D1           Is it normalised?
           BVS.S       Norlised        If so, return it.
           SUBQ.W      #1,D4           Not ready, halve exponent.
           MOVE.L      D1,D5           Doubled mantissa moved to D5.
           MOVEQ       #16,D0          Try 16 bit shift first.
*
Normalise  MOVE.L      D5,D1           Make copy of mantissa.
           ASL.L       D0,D1           Shift mantissa D0 places left.
           BVS.S       Too_Far         Try next shift distance.
           SUB.W       D0,D4           correct exponent for that shift.
           MOVE.L      D1,D5           New mantissa is closer.
Too_Far    ASR.W       #1,D0           Half the shift distance for next try.
           BNE.S       Normalise       Half the previous shift each time.
*
* Make sure there is enough space for the result.
*
Norlised   MOVEQ       #6,D1           Number of bytes needed is 6.
           MOVE.W      $11A,A0         Select BV.CHRIX to reserve space.
           JSR         (A0)            Call the routine
           MOVE.L      $58(A6),A1      Fetch safe A1 value.
           SUBQ.L      #6,A1           Point to the new value.
           MOVE.L      A1,$58(A6)      update stack pointer.
           MOVE.L      D5,2(A1,A6.L)   Stack the mantissa.
           MOVE.W      D4,0(A1,A6.L)   Stack the exponent.
           MOVEQ       #2,D4           Indicate floating point result.
           MOVEQ       #0,D0           Indicate no error.
           RTS
*
Defines    DC.W        0               No PROCedures
           DC.W        0               End of PROCedure list.
           DC.W        1               One FuNction
           DC.W        DateFind-*      Position of code for FuNction
           DC.B        4               Length of name
           DC.B        'DATE'          Characters of name
           DC.W        0               End of FuNction list
           END
